#ifndef HANDLERS_H
#define HANDLERS_H

enum Handlers
{
  //ECU HANDLERS
  Handler_ECU_NOP,
  Handler_Halt,
  Handler_BRAAlways,
  Handler_BRAAlways_NOP,
  Handler_BRAConditional,
  Handler_BRAConditional_NOP,
  Handler_JMPAlwaysIndirect,
  Handler_JMPAlwaysIndirect_NOP,
  Handler_JMPConditionalIndirect,
  Handler_JMPConditionalIndirect_NOP,
  Handler_JSRAlways,
  Handler_JSRAlways_NOP,
  Handler_JSRConditional,
  Handler_JSRConditional_NOP,
  Handler_JSRAlwaysIndirect,
  Handler_JSRAlwaysIndirect_NOP,
  Handler_JSRConditionalIndirect,
  Handler_JSRConditionalIndirect_NOP,
  Handler_RTI1Conditional,
  Handler_RTI1Conditional_NOP,
  Handler_RTI2Conditional,
  Handler_RTI2Conditional_NOP,
  Handler_RTSAlways,
  Handler_RTSAlways_NOP,
  Handler_RTSConditional,
  Handler_RTSConditional_NOP,
  //RCU HANDLERS
  Handler_DECRc1,
  Handler_DECRc0,
  Handler_DECBoth,
  Handler_ADDRImmediateOnly,
  Handler_ADDRImmediate,
  Handler_ADDRScalarOnly,
  Handler_ADDRScalar,
  Handler_MVRImmediateOnly,
  Handler_MVRImmediate,
  Handler_MVRScalarOnly,
  Handler_MVRScalar,
  Handler_RangeOnly,
  Handler_Range,
  Handler_ModuloOnly,
  Handler_Modulo,
  //ALU HANDLERS
  Handler_ABS,
  Handler_BITSScalar,
  Handler_BITSImmediate,
  Handler_BTST,
  Handler_BUTT,
  Handler_COPY,
  Handler_MSB,
  Handler_SAT,
  Handler_AS,
  Handler_ASL,
  Handler_ASR,
  Handler_LS,
  Handler_LSR,
  Handler_ROT,
  Handler_ROL,
  Handler_ROR,
  Handler_ADD_P,
  Handler_SUB_P,
  Handler_ADD_SV,
  Handler_SUB_SV,
  Handler_ADDImmediate,
  Handler_ADDScalar,
  Handler_ADDScalarShiftRightImmediate,
  Handler_ADDScalarShiftLeftImmediate,
  Handler_SUBImmediate,
  Handler_SUBImmediateReverse,
  Handler_SUBScalar,
  Handler_SUBScalarShiftRightImmediate,
  Handler_SUBScalarShiftLeftImmediate,
  Handler_CMPImmediate,
  Handler_CMPImmediateReverse,
  Handler_CMPScalar,
  Handler_CMPScalarShiftRightImmediate,
  Handler_CMPScalarShiftLeftImmediate,
  Handler_ANDImmediate,
  Handler_ANDScalar,
  Handler_ANDImmediateShiftScalar,
  Handler_ANDScalarShiftRightImmediate,
  Handler_ANDScalarShiftLeftImmediate,
  Handler_ANDScalarShiftScalar,
  Handler_ANDScalarRotateScalar,
  Handler_FTSTImmediate,
  Handler_FTSTScalar,
  Handler_FTSTImmediateShiftScalar,
  Handler_FTSTScalarShiftRightImmediate,
  Handler_FTSTScalarShiftLeftImmediate,
  Handler_FTSTScalarShiftScalar,
  Handler_FTSTScalarRotateScalar,
  Handler_ORImmediate,
  Handler_ORScalar,
  Handler_ORImmediateShiftScalar,
  Handler_ORScalarShiftRightImmediate,
  Handler_ORScalarShiftLeftImmediate,
  Handler_ORScalarShiftScalar,
  Handler_ORScalarRotateScalar,
  Handler_EORImmediate,
  Handler_EORScalar,
  Handler_EORImmediateShiftScalar,
  Handler_EORScalarShiftRightImmediate,
  Handler_EORScalarShiftLeftImmediate,
  Handler_EORScalarShiftScalar,
  Handler_EORScalarRotateScalar,
  Handler_ADDWCScalar,
  Handler_ADDWCImmediate,
  Handler_ADDWCScalarShiftRightImmediate,
  Handler_ADDWCScalarShiftLeftImmediate,
  Handler_SUBWCScalar,
  Handler_SUBWCImmediate,
  Handler_SUBWCImmediateReverse,
  Handler_SUBWCScalarShiftRightImmediate,
  Handler_SUBWCScalarShiftLeftImmediate,
  Handler_CMPWCScalar,
  Handler_CMPWCImmediate,
  Handler_CMPWCImmediateReverse,
  Handler_CMPWCScalarShiftRightImmediate,
  Handler_CMPWCScalarShiftLeftImmediate,
  //MUL HANDLERS
  Handler_ADDM,
  Handler_ADDMImmediate,
  Handler_SUBM,
  Handler_SUBMImmediateReverse,
  Handler_MULScalarShiftAcshift,
  Handler_MULScalarShiftRightImmediate,
  Handler_MULScalarShiftLeftImmediate,
  Handler_MULImmediateShiftAcshift,
  Handler_MULScalarShiftScalar,
  Handler_MULImmediateShiftScalar,
  Handler_MULImmediateShiftRightImmediate,
  Handler_MULImmediateShiftLeftImmediate,
  Handler_MUL_SVImmediateShiftImmediate,
  Handler_MUL_SVScalarShiftImmediate,
  Handler_MUL_SVScalarShiftSvshift,
  Handler_MUL_SVRuShiftImmediate,
  Handler_MUL_SVRuShiftSvshift,
  Handler_MUL_SVRvShiftImmediate,
  Handler_MUL_SVRvShiftSvshift,
  Handler_MUL_SVVectorShiftImmediate,
  Handler_MUL_SVVectorShiftSvshift,
  Handler_MUL_PImmediateShiftImmediate,
  Handler_MUL_PScalarShiftImmediate,
  Handler_MUL_PScalarShiftSvshift,
  Handler_MUL_PRuShiftImmediate,
  Handler_MUL_PRuShiftSvshift,
  Handler_MUL_PRvShiftImmediate,
  Handler_MUL_PRvShiftSvshift,
  Handler_MUL_PVectorShiftImmediate,
  Handler_MUL_PVectorShiftSvshift,
  Handler_DOTPScalarShiftImmediate,
  Handler_DOTPScalarShiftSvshift,
  Handler_DOTPVectorShiftImmediate,
  Handler_DOTPVectorShiftSvshift,
  //MEM HABDLERS
  Handler_Mirror,
  Handler_MV_SImmediate,
  Handler_MV_SScalar,
  Handler_MV_V,
  Handler_PopVector,
  Handler_PopVectorRz,
  Handler_PopScalarRzi1,
  Handler_PopScalarRzi2,
  Handler_PushVector,
  Handler_PushVectorRz,
  Handler_PushScalarRzi1,
  Handler_PushScalarRzi2,
  Handler_LoadScalarLinear,
  Handler_LoadScalarControlRegisterAbsolute,
  Handler_LoadByteAbsolute,
  Handler_LoadWordAbsolute,
  Handler_LoadScalarAbsolute,
  Handler_LoadShortVectorAbsolute,
  Handler_LoadVectorAbsolute,
  Handler_LoadVectorControlRegisterAbsolute,
  Handler_LoadPixelAbsolute,
  Handler_LoadPixelZAbsolute,
  Handler_LoadByteLinear,
  Handler_LoadByteBilinearUV,
  Handler_LoadByteBilinearXY,
  Handler_LoadWordLinear,
  Handler_LoadWordBilinearUV,
  Handler_LoadWordBilinearXY,
  Handler_LoadScalarBilinearUV,
  Handler_LoadScalarBilinearXY,
  Handler_LoadShortVectorLinear,
  Handler_LoadShortVectorBilinearUV,
  Handler_LoadShortVectorBilinearXY,
  Handler_LoadVectorLinear,
  Handler_LoadVectorBilinearUV,
  Handler_LoadVectorBilinearXY,
  Handler_LoadPixelLinear,
  Handler_LoadPixelBilinearUV,
  Handler_LoadPixelBilinearXY,
  Handler_LoadPixelZLinear,
  Handler_LoadPixelZBilinearUV,
  Handler_LoadPixelZBilinearXY,
  Handler_StoreScalarAbsolute,
  Handler_StoreScalarControlRegisterAbsolute,
  Handler_StoreShortVectorAbsolute,
  Handler_StoreVectorAbsolute,
  Handler_StoreVectorControlRegisterAbsolute,
  Handler_StorePixelAbsolute,
  Handler_StorePixelZAbsolute,
  Handler_StoreScalarLinear,
  Handler_StoreScalarBilinearUV,
  Handler_StoreScalarBilinearXY,
  Handler_StoreShortVectorLinear,
  Handler_StoreShortVectorBilinearUV,
  Handler_StoreShortVectorBilinearXY,
  Handler_StoreVectorLinear,
  Handler_StoreVectorBilinearUV,
  Handler_StoreVectorBilinearXY,
  Handler_StorePixelLinear,
  Handler_StorePixelBilinearUV,
  Handler_StorePixelBilinearXY,
  Handler_StorePixelZLinear,
  Handler_StorePixelZBilinearUV,
  Handler_StorePixelZBilinearXY,
  Handler_StoreScalarControlRegisterImmediate,
  Handler_StoreScalarImmediate,
  //MISC Handlers
  Handler_StoreScalarRegisterConstant,
  Handler_StoreMiscRegisterConstant,
  Handler_PacketStart,
  Handler_PacketEnd,
  Handler_CheckECUSkipCounter,
  Handler_SaveFlags,
  Handler_SaveRegs,
};
#endif